#!/usr/bin/perl

# =============================================================================

if( $#ARGV < 1 || $#ARGV > 3 ) { usage(); }

open( FILE, $ARGV[0] ) || die "file $ARGV[0] not found.\n";

# .. variabledeclarations .....................................................
$interval = 1; # size of a step to increase counter
$counter = 0;  # actual interval
$sizeSum = 0;  # throughput in an interval
$printsum = 0;
# .............................................................................

while( $line = <FILE> ) # read line by line from <FILE>
{
  @word = split( '\s+', $line ); # split columns of a line and save into array
  # word[0]: event ('r': receive, '+': enqueue, '-': dequeue, 'd': drop)
  # word[1]: actual time (timestamp)
  # word[2]: from node
  # word[3]: to node
  # word[4]: packet type
  # word[5]: packet size

  if( $word[4] eq $ARGV[1] && $word[0] eq "r" )
  {
    if( $#ARGV < 2 || $word[3] eq $ARGV[2] )
    {
      if( $#ARGV < 3 || $word[2] eq $ARGV[3] )
      {
        $timestamp = $word[1]; # get actual timestamp from array

        if( $timestamp - $counter <= $interval ) { $sizeSum += ($word[5]*8.0); }
        else
        {
          $counter += $interval;        # increase counter
	  $printsum = $sizeSum / 1000.0;
          print "$counter\t$printsum\n"; # print aktual time and throughput

          while( $timestamp - $counter > $interval )
          {
              $counter += $interval; # shrink difference bet. timest. & counter
              print "$counter\t0\n"; # print 0-line if no dataflow was recorded
          }

          $sizeSum = ($word[5]*8.0); # last paket size stored for usage in next round
        }
      }
    }
  }
}
close( FILE );

# print remaining throughput
$printsum = $sizeSum / 1000.0;
print $counter += $interval; print "\t"; print $printsum; print "\n";

exit;

# -----------------------------------------------------------------------------

sub usage
{
  print STDERR "throughput:\tprint received bandwidth\n";
  print STDERR "Usage:\t\tthroughput.pl file.tr type [dst [scr]]\n";
  print STDERR "Example types:\ttcp, ack, udp, cbr\n";
  exit;
}

# =============================================================================
